//#include <cstdlib>
//#include <iostream>
//#include <pthread.h>
//#include <queue>

#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
//#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

struct midi_in_list_node
{
	int midi_in_number;
	HMIDIIN midi_in;
	struct midi_in_list_node *next_midi_in_list_node;
};

typedef struct
{
    char key[4];
    unsigned short frameType;        // 0x01 = rowData
    unsigned short offTime_ms;       // time off in ms
    unsigned short onTime_50us[24];  // on time in 50us divisions
                                     //  i.e. onTime[0] = 2 would indicate 100us
} rowData;

rowData row;

struct midi_in_list_node *first_midi_in_list_node = NULL;
int status[100];

void yarr(int,int);

void CALLBACK midi_in_handler(HMIDIIN midi_in, UINT msg_type, DWORD user_data, DWORD midi_msg, DWORD param2)
{
	int midi_in_number;

	midiInGetID(midi_in, &midi_in_number);

	if (msg_type == MIM_DATA)
	{
		union
		{
			DWORD dwData;
			BYTE bData[4];
		}
		u;

		u.dwData = midi_msg;
		switch (u.bData[0] & 0xF0)
		{
			case 0x80:
			{
				printf(" %3d | %02X %02X %02X | Note Off         | Channel %2d | Pitch    %3d | Velocity %3d\n", midi_in_number, u.bData[0], u.bData[1], u.bData[2], u.bData[0] & 0x0F, u.bData[1], u.bData[2]);
				break;
			}
			case 0x90:
			{
				printf(" %3d | %02X %02X %02X | Note On          | Channel %2d | Pitch    %3d | Velocity %3d\n", midi_in_number, u.bData[0], u.bData[1], u.bData[2], u.bData[0] & 0x0F, u.bData[1], u.bData[2]);
				yarr(u.bData[1], u.bData[2]);
				break;
			}
			case 0xA0:
			{
				printf(" %3d | %02X %02X %02X | Key Pressure     | Channel %2d | Pitch    %3d | Amount   %3d\n", midi_in_number, u.bData[0], u.bData[1], u.bData[2], u.bData[0] & 0x0F, u.bData[1], u.bData[2]);
				break;
			}
			case 0xB0:
			{
				printf(" %3d | %02X %02X %02X | Control Change   | Channel %2d | Number   %3d | Value    %3d\n", midi_in_number, u.bData[0], u.bData[1], u.bData[2], u.bData[0] & 0x0F, u.bData[1], u.bData[2]);
				break;
			}
			case 0xC0:
			{
				printf(" %3d | %02X %02X    | Program Change   | Channel %2d | Number   %3d |\n", midi_in_number, u.bData[0], u.bData[1], u.bData[0] & 0x0F, u.bData[1]);
				break;
			}
			case 0xD0:
			{
				printf(" %3d | %02X %02X    | Channel Pressure | Channel %2d | Amount   %3d |\n", midi_in_number, u.bData[0], u.bData[1], u.bData[0] & 0x0F, u.bData[1]);
				break;
			}
			case 0xE0:
			{
				printf(" %3d | %02X %02X %02X | Pitch Wheel      | Channel %2d | Amount %5d |\n", midi_in_number, u.bData[0], u.bData[1], u.bData[2], u.bData[0] & 0x0F, (int)(u.bData[2]) << 7 | (int)(u.bData[1]));
				break;
			}
		}

		fflush(stdout);
	}
}

BOOL WINAPI control_handler(DWORD control_type)
{
	struct midi_in_list_node *midi_in_list_node, *next_midi_in_list_node;

	for (midi_in_list_node = first_midi_in_list_node; midi_in_list_node != NULL; midi_in_list_node = next_midi_in_list_node)
	{
		next_midi_in_list_node = midi_in_list_node->next_midi_in_list_node;
		midiInStop(midi_in_list_node->midi_in);
		midiInClose(midi_in_list_node->midi_in);
		free(midi_in_list_node);
	}

	return FALSE;
}
int status[100];
void yarr(int note, int velocity) {
	int i;
	note = note - 0x24;
	status[note] = velocity;
	row.onTime_50us[note % 24] = velocity;

	//printf("%d %d\n", in, in2);
}

int sendData(fd)
{    
    unsigned char inData;
    if (fd < 0)
    {
        printf("Couldn't open %d\n", fd);   
        return -1;
    }
//    RowData2 test;
//    unsigned char frameType = 0x00;

        printf("Waiting for ACK\n");
		inData = 0;
        read(fd, &inData, 1);
		
        if (inData == 0x06) //Wait for ACK from microcontroller
        {
            printf("ACK Received: Writing %d bytes.\n", sizeof(row));
//            printf("Row Data2 %d\n", sizeof(test));
            //write(fd, &frameType, 1); //Write Frame Type
            write(fd, &row, sizeof(row));
			Sleep(50);
//			printf("Written\n");
        } else {
			close(fd);
			fd = open("COM3", O_RDWR);
		}
//		printf("Close\n");
  //  close(fd);
//	printf("RET\n");
    return 0;
}

int main(int argc, char **argv)
{
	int i;
	int fd;
	int count;
	int closed;
	char mode;
	FILE *myFile;
	struct midi_in_list_node *midi_in_list_node;
	
	mode = 'F';
	closed = 1;
	
	for (i = 0; i < 100; i++) {
		status[i] = 0;
	}
	
	row.key[0] = 'F';
	row.key[1] = 'Y';
	row.key[2] = 'D';
	row.key[3] = 'P';
	row.frameType = 2;
	row.offTime_ms = 0;

	for (i = 1; i < argc; i++)
	{
		if (strcmp(argv[i], "--in") == 0)
		{
			int midi_in_number = 0;

			if (++i >= argc) break;
			if (sscanf(argv[i], "%d", &midi_in_number) != 1) break;

			midi_in_list_node = (struct midi_in_list_node *)(malloc(sizeof (struct midi_in_list_node)));
			midi_in_list_node->midi_in_number = midi_in_number;
			midi_in_list_node->next_midi_in_list_node = first_midi_in_list_node;
			first_midi_in_list_node = midi_in_list_node;
		}
		else
		{
			printf("Usage: %s [--in <n>] ...\n", argv[0]);
			return 1;
		}
	}

	if (first_midi_in_list_node == NULL)
	{
		first_midi_in_list_node = (struct midi_in_list_node *)(malloc(sizeof (struct midi_in_list_node)));
		first_midi_in_list_node->midi_in_number = 0;
		first_midi_in_list_node->next_midi_in_list_node = NULL;
	}

	for (midi_in_list_node = first_midi_in_list_node; midi_in_list_node != NULL; midi_in_list_node = midi_in_list_node->next_midi_in_list_node)
	{
		if (midiInOpen(&(midi_in_list_node->midi_in), midi_in_list_node->midi_in_number, (DWORD)(midi_in_handler), (DWORD)(NULL), CALLBACK_FUNCTION) != MMSYSERR_NOERROR)
		{
			printf("PPPCannot open MIDI input port #%d.\n", midi_in_list_node->midi_in_number);
			return 1;
		}
	}

	SetConsoleCtrlHandler(control_handler, TRUE);

	for (midi_in_list_node = first_midi_in_list_node; midi_in_list_node != NULL; midi_in_list_node = midi_in_list_node->next_midi_in_list_node)
	{
		midiInStart(midi_in_list_node->midi_in);
	}
	fd = open("COM3", O_RDWR);
	closed = 0;
	count = 0;
	while (1) {
	
		myFile = fopen("C:/BubbleDisplay/mode.txt", "r");
		if (!myFile) {
			printf("Could not open mode.txt.\n");
			return -1;
		}
		mode = fgetc(myFile);
		fclose(myFile);
		//printf("Mode: %c\n", mode);
		if (mode == '1') {
			if (closed == 1) {
				fd = -1;
				fd = open("COM3", O_RDWR);
				if (fd < 0) {
					printf("Couldn't open COM3\n");
					printf("Trying Hard!\n");
				}
				while(fd < 0) {
					fd = open("COM3", O_RDWR);
				}
				if (fd < 0) {
					printf("Couldn't get COM\n");
					return -1;
				}
				closed = 0;
			}
			sendData(fd);
			count++;
		} else {
			closed = 1;
			close(fd);
			Sleep(10);
		}
	}
	close(fd);
	Sleep(INFINITE);
	return 0;
}

