#include <cstdlib>
#include <iostream>
//#include <pthread.h>
#include <queue>

#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */

#include "bubble_hal.h"

int closed = 1;


//This code is borrowed from an online tutorial, is used for debugging purposes and will be removed from
//the final implementation
void hexdump(void* mybuff, int len, char * name){
	int i=0,j=0,k=0;
	unsigned char* buff=(unsigned char*)mybuff;
	if(!buff) return;
	printf("\n*************************** %s ***************************\n", name);
	for(;i<len;i++){
		// Print Hex Stuff
		printf("%02X",buff[i]);
	
		// Print Ascii at the end of the line
		// Line length is 16 Hex and 16 Characters
		if(i==len-1){
			// The End of the last Hex line
			for(k=0;k<16-(i%16);k++) printf("   ");
			for(;j<=i;j++){
				// Only print printable ascii characters
				if((buff[j]>=32)&&(buff[j]<=126)) printf("%c",buff[j]);
				else printf(".");
			}	
		}else if(i%16 == 15){
			// The End of a normal Hex line
			printf("   ");
			for(;j<=i;j++){
				// Only print printable ascii characters
				if((buff[j]>=32)&&(buff[j]<=126)) printf("%c",buff[j]);
				else printf(".");
			}
			j=i+1;	
			printf("\n");
		}else{
			// Just between Hex characters
			printf(".");
		}
	}
	printf("\n*******************************************************************\n");
}


using namespace std;

#if 0
struct rowData
{
	unsigned short frameType; //0x01 = rowData
	unsigned short offTime_ms; //time off in ms
	unsigned short onTime_50us[24];
};

struct performanceData
{
	unsigned int num_loops;
	unsigned short fifty_micros;
};
#endif

#if 0
struct rowData
{
	unsigned char frameType; //0x01 = rowData
	unsigned int offTime; //time off in ms
	unsigned int onTime[24];
};
#endif

std::queue<rowData> rows;
#if 0
Constructors	construct a new queue
back	returns a reference to last element of a queue
empty	true if the queue has no elements
front	returns a reference to the first element of a queue
pop	removes the first element of a queue
push	adds an element to the end of the queue
size	returns the number of items in the queue
#endif

int addRow(rowData rData)
{
    rData.key[0] = 'F';
    rData.key[1] = 'Y';
    rData.key[2] = 'D';
    rData.key[3] = 'P';
       rows.push(rData);       
}

int sendData(char * inString)
{
    int fd = open(inString, O_RDWR);
    printf("Open Thing\n");
    unsigned char inData;
    if (fd < 0)
    {
        printf("Couldn't open %s\n", inString);   
        printf("Trying Hard!\n");        
    }
    while (fd < 0) {
          fd = open(inString, O_RDWR);
          }
//    RowData2 test;
    unsigned char frameType = 0x00;
    while (!rows.empty())
    {
        printf("Waiting for ACK\n");
        read(fd, &inData, 1);
        if (inData == 0x06) //Wait for ACK from microcontroller
        {
            printf("ACK Received: Writing %d bytes.\n", sizeof(rows.front()));
//            printf("Row Data2 %d\n", sizeof(test));
            //write(fd, &frameType, 1); //Write Frame Type
            write(fd, &rows.front(), sizeof(rows.front())/1);
            rows.pop();
        }
    }
        printf("Close Thing\n");
    close(fd);
    return 0;
}

int readPerformanceData(char * inString, performanceData * pData)
{
    int fd = open(inString, O_RDWR);   
    //performanceData pData;
    int bytesRead = 0;
    if (fd < 0)
    {
        printf("Couldn't open %s\n", inString);   
        return -1;
    }
    //char buff[8];
    //memset(buff, 0xff, 8);
    //hexdump(pData, sizeof(*pData), "pData1");
    while(bytesRead < sizeof(*pData))
    {
      bytesRead += read(fd, pData, sizeof(*pData));
      //printf("Bytes Read: %d\n", bytesRead);
      //printf("Sizeof(pData) = %d\n", sizeof(*pData));
    }
    //hexdump(pData, sizeof(*pData), "pData2");
    close(fd);
    return 0;
}

#if 0
int main(int argc, char *argv[])
{
    rowData rData;
    performanceData pData;
    //hexdump(&pData, sizeof(pData), "pData");
    //printf("Size: %d\n", sizeof(rData));
    rData.offTime_ms = 350;
    
    for (int i = 0; i < 24; i++)
    {
        //rData.onTime_50us[i] = 20000+(i*1000);    	
        rData.onTime_50us[i] = 600; //300 * 50uS = 15 ms
    }

rData.onTime_50us[0] = 590;
rData.onTime_50us[1] = 580;
rData.onTime_50us[2] = 740;
rData.onTime_50us[3] = 720;
rData.onTime_50us[4] = 730;
rData.onTime_50us[5] = 560;
rData.onTime_50us[6] = 470;
rData.onTime_50us[7] = 650;
rData.onTime_50us[8] = 680;
rData.onTime_50us[9] = 570;
rData.onTime_50us[10] = 580;
rData.onTime_50us[11] = 500;
rData.onTime_50us[12] = 560;
rData.onTime_50us[13] = 680;
rData.onTime_50us[14] = 550;
rData.onTime_50us[15] = 920;
rData.onTime_50us[16] = 830;
rData.onTime_50us[17] = 680;
rData.onTime_50us[18] = 570;
rData.onTime_50us[19] = 680;
rData.onTime_50us[20] = 600;  //Last Valve
rData.onTime_50us[21] = 600;
rData.onTime_50us[22] = 600;
rData.onTime_50us[23] = 600;

    while(true)
    {
        addRow(rData);
        sendData("COM6");
        readPerformanceData("COM6", &pData);
        float rate = (float)pData.num_loops / (float)pData.fifty_micros;
        printf("pData.num_loops = %d    pData.fifty_micros = %d   Rate: %f\n\n", pData.num_loops, pData.fifty_micros, rate);
//	unsigned int num_loops;
//	unsigned short fifty_micros;
    }
    system("PAUSE");
    return EXIT_SUCCESS;
}
#endif

#if TEST1
    for (int i = 0; i < 24; i++)
    {
    	if (i % 2 == 0)
    	{
    		rData.onTime_50us[i] =32000;
    	}
    	else
    	{
    		rData.onTime_50us[i] = 47040;
    	}    	
    }
    #endif
