#ifndef _bubble_h_
#define _bubble_h_

// struct declarations to allow usage of structs in other files
typedef struct
{
    char key[4];
    unsigned short frameType;        // 0x01 = rowData
    unsigned short offTime_ms;       // time off in ms
    unsigned short onTime_50us[24];  // on time in 50us divisions
                                     //  i.e. onTime[0] = 2 would indicate 100us
} rowData;

typedef struct 
{
	unsigned int num_loops;
	unsigned short fifty_micros;
} performanceData;

// function declarations to allow access to functions from other files
int addRow(rowData rData);

int sendData(char * inString);

int readPerformanceData(char * inString, performanceData * pData);

#endif
